require 'RMagick'

require './cpm_disk.rb'

def legend_text(text,color,x,y,canvas)
	gc = Magick::Draw.new

	gc.stroke_antialias(true)
	gc.text_antialias(false)
	gc.font_weight(Magick::NormalWeight)
	gc.font_style(Magick::NormalStyle)
	gc.font_stretch(Magick::UltraCondensedStretch)
	gc.pointsize(16)

	gc.opacity(1)
	gc.fill_opacity(1)	

	gc.fill(color)
	gc.stroke(color)
	#gc.rectangle(x,y,x+45,y+45)

	#gc.gravity(Magick::WestGravity)
	#gc.text_align(Magick::LeftAlign)
	

	gc.stroke("black")
	gc.text_undercolor(color)
	gc.text(x,y+10,text)

	gc.draw(canvas)
end


def xblock(text,color,x,y,dx,dy,canvas)
	gc = Magick::Draw.new


	gc.stroke_antialias(true)
	gc.text_antialias(false)
	gc.font_weight(Magick::NormalWeight)
	gc.font_style(Magick::NormalStyle)
	gc.font_stretch(Magick::UltraCondensedStretch)
	gc.pointsize(16)

	gc.opacity(1)
	gc.fill_opacity(0)	

	gc.stroke(color)
	gc.text(x,@base_y+y-5,text)

	#gc.fill(color)
	gc.stroke(color)
	gc.rectangle(x,@base_y+y,x+dx,@base_y+y+dy)


	gc.draw(canvas)
end



def test(canvas,blocks_map)
	gc = Magick::Draw.new

	gc.stroke_antialias(true)
	# gc.text_antialias(false)
	# gc.font_weight(Magick::NormalWeight)
	# gc.font_style(Magick::NormalStyle)
	# gc.font_stretch(Magick::UltraCondensedStretch)
	# gc.pointsize(16)

	gc.opacity(1)
	gc.fill_opacity(0)	

	# gc.stroke(color)
	# gc.text(x,@base_y+y-5,text)

	#gc.fill(color)
	# gc.stroke(color)
	# gc.rectangle(x,@base_y+y,x+dx,@base_y+y+dy)


	xx=25
	yy=20

	dx=16
	dy=25

	0.upto(yy) do |y|
		0.upto(xx) do |x|
			ii=xx*y+x
			# p [x,y,ii]
			color="black"
			if ii<blocks_map.size
				color=blocks_map[ii] ? "green" : "cyan"
				color="blue" if blocks_map[ii]==-1
				x0=x*dx
				y0=y*dy

				gc.stroke(color)
				gc.rectangle(x0,y0,x0+dx-1,y0+dy-1)
			end

		end
	end



	gc.draw(canvas)
end



def make_map(disk,dst_name)
	_image = Magick::Image.new(700,480)



	block_size=128*(disk.get_dpb.blm+1)
	system_track_on_disk=disk.get_dpb.ofs
	track_size=disk.get_dpb.spt*128

	system_blocks=system_track_on_disk*track_size/block_size

	p [system_track_on_disk,track_size,block_size,system_blocks]

	blocks_on_disk=disk.get_dpb.dsm
	blocks_map=Array.new(blocks_on_disk,false)

	disk.get_dir.each do |dir_entry|
		dir_entry.used_blocks.each do |block|
			# if block>blocks_on_disk
			# 	p [:chkdsk,:block_to_big,dir_entry.filename,block]
			# 	error_flag=true
			# else
			# 	if owner=blocks_map[block]
			# 		p [:chkdsk,:block_used,dir_entry.filename,block,owner.filename]
			# 		error_flag=true
			# 	else
			# 		blocks_map[block]=dir_entry
			# 	end
			# end
			blocks_map[block]=true if block<blocks_on_disk
		end
	end

	blocks_map=Array.new(system_blocks,-1)+blocks_map

 	p blocks_map



	test(_image,blocks_map)

	_image.write(dst_name)
end

def main
	#_disk_drv=KDI.new("./KDI/disk1.kdi")
	#_disk_drv=KDI.new("./KDI/disk2.kdi")
	#_disk_drv=KDI.new("./KDI/disk3.kdi")
	#_disk_drv=KDI.new("./KDI/disk4.kdi")
	#_disk_drv=KDI.new("./KDI/AG_dict_en-ru.kdi")
	list=Dir["/home/serokhin/Dropbox/Emulator/Korvet/KorvetSoft/**/*.kdi"]
	list+=Dir["/home/serokhin/Dropbox/Emulator/Korvet/KorvetSoft/**/*.KDI"]
	# list=Dir["/Users/esl/Dropbox/Emulator/Korvet/KorvetSoft/**/*.kdi"]
	# list+=Dir["/Users/esl/Dropbox/Emulator/Korvet/KorvetSoft/**/*.KDI"]
	# list=["/home/serokhin/Dropbox/Emulator/Korvet/KorvetSoft/Shtirlitz/DE_6_01.kdi"]
	#list=["/home/serokhin/Dropbox/Emulator/Korvet/KorvetSoft/AlexanderGrigoryev/AG_kornet_drive-a_gamz.kdi"]

	disk_with_error=0
	list=list.sort
	list.each do |name|
		p [:name,name]
		begin

			_disk_drv=KDI.new(name)
			disk=CPM_Drive.new(_disk_drv)
			# puts disk.dir.get_dir
			# file_out.puts disk.get_dir

			# fnames=disk.get_dir.map{|v| user=v.user>0?"\t\t\t#{v.user}:" : ""; "#{user}#{v.filename}"}
			# puts fnames


			#disk_with_error+=1 if disk.check_disk

			gmap_name=name.clone.downcase
			gmap_name.gsub!(/.*Korvet\/KorvetSoft\//i,"")
			gmap_name.gsub!(/\//,"_")

			gmap_name.gsub!(/\.kdi$/,".png")
			gmap_name="./maps/#{gmap_name}"

			make_map(disk,gmap_name)
			# p [:name2,name2]
			# p [:spt,disk.get_dpb.spt]
			# p [:blm,128*(disk.get_dpb.blm+1)]

			# disk.get_dir.each do |entry|
			# 	p entry.used_blocks
			# 	# File.open("1/#{entry.filename}", "w") { |io| io.puts disk.get_file(entry)  }
			# end
		# rescue Exception => e
		# 	puts "Exception: " 
		# 	puts e#.message  
		end
	end
	# p [:disk,list.size]
	# p [:with_error,disk_with_error]
	#xd=disk.d2
	#p xd
	# 0.upto(127-1) { |n|
	# 	p [n,xd[n]] if xd[n] #unless disk.raw_dir.dir[n].status == 0xe5
	# }
end

main